package com.zhiwei_tech.openapidemo;

/**
 * Created by zhenggary on 15/8/31.
 */

import android.content.Context;
import android.content.SharedPreferences;
import android.preference.PreferenceManager;

public class SaveSharedPreference {
    static final String PREF_SCHOOL_ID = "school_id";
    static final String PREF_PASS = "pass";
    static final String PREF_TESTINFO = "test_info";


    static SharedPreferences getSharedPreferences(Context ctx) {
        return PreferenceManager.getDefaultSharedPreferences(ctx);
    }

    public static void setVariable(Context ctx, final String id, String value) {
        SharedPreferences.Editor editor = getSharedPreferences(ctx).edit();
        editor.putString(id, value);
        editor.commit();
    }

    public static void clearVariable(Context ctx, final String id) {
        SharedPreferences.Editor editor = getSharedPreferences(ctx).edit();
        editor.remove(id);
        editor.commit();
    }

    public static void clearAlldata(Context ctx) {
        SharedPreferences.Editor editor = getSharedPreferences(ctx).edit();
        editor.clear();
        editor.commit();
    }

    public static String getSchoolId(Context ctx) {
        return getSharedPreferences(ctx).getString(PREF_SCHOOL_ID, "");
    }

    public static String getPass(Context ctx) {
        return getSharedPreferences(ctx).getString(PREF_PASS, "");
    }

    public static String getTestInfo(Context ctx) {
        return getSharedPreferences(ctx).getString(PREF_TESTINFO, "");
    }

    public static String getScoreByTid(Context ctx, String tid) {
        return getSharedPreferences(ctx).getString(tid, "");
    }


}