package com.zhiwei_tech.openapidemo;

import java.io.ByteArrayOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.URL;
import java.net.HttpURLConnection;

import javax.net.ssl.HttpsURLConnection;
import javax.net.ssl.TrustManager;
import javax.net.ssl.X509TrustManager;

import java.security.cert.X509Certificate;

import javax.net.ssl.SSLContext;

import java.security.SecureRandom;


public class WeikeUtility {
    public static String GetDataByPost(String postUrl, String postData) {
        //声明返回变量
        String DataInfo = "";
        try {
            // 传递的数据
            String data = postData;
            // 根据地址创建URL对象
            URL url = new URL(postUrl);
            //忽略证书验证
            // 根据URL对象打开链接
            HttpURLConnection urlConnection = null;

            // Create a trust manager that does not validate certificate chains 创建一个trust manager
            TrustManager[] trustAllCerts = new TrustManager[]{new X509TrustManager() {
                public X509Certificate[] getAcceptedIssuers() {
                    return null;
                }

                public void checkClientTrusted(X509Certificate[] certs, String authType) {
                }

                public void checkServerTrusted(X509Certificate[] certs, String authType) {
                }
            }};
            // Install the all-trusting trust manager 信任所有证书
            try {
                // 注意这部分一定要
                HttpsURLConnection.setDefaultHostnameVerifier(new NullHostNameVerifier());
                SSLContext sc = SSLContext.getInstance("TLS");
                sc.init(null, trustAllCerts, new SecureRandom());
                HttpsURLConnection.setDefaultSSLSocketFactory(sc.getSocketFactory());
                urlConnection = (HttpURLConnection) url.openConnection();
                // 设置请求的方式
                urlConnection.setRequestMethod("POST");
                // 设置请求的超时时间
                urlConnection.setReadTimeout(4000);
                urlConnection.setConnectTimeout(4000);

                // 设置请求的头
                urlConnection.setRequestProperty("Connection", "keep-alive");
                // 设置请求的头
                urlConnection.setRequestProperty("Content-Type",
                        "application/x-www-form-urlencoded");
                // 设置请求的头
                urlConnection.setRequestProperty("Content-Length",
                        String.valueOf(data.getBytes().length));
                // 设置请求的头
                urlConnection
                        .setRequestProperty("User-Agent",
                                "Mozilla/5.0 (Windows NT 6.3; WOW64; rv:27.0)" +
                                        " Gecko/20100101 Firefox/27.0");

                urlConnection.setDoOutput(true); // 发送POST请求必须设置允许输出
                urlConnection.setDoInput(true); // 发送POST请求必须设置允许输入
            } catch (Exception e) {
                e.printStackTrace();
            }

            //setDoInput的默认值就是true
            //获取输出流
            OutputStream os = urlConnection.getOutputStream();
            os.write(data.getBytes());
            os.flush();
            if (urlConnection.getResponseCode() == 200) {
                // 获取响应的输入流对象
                InputStream is = urlConnection.getInputStream();
                // 创建字节输出流对象
                ByteArrayOutputStream baos = new ByteArrayOutputStream();
                // 定义读取的长度
                int len = 0;
                // 定义缓冲区
                byte buffer[] = new byte[1024];
                // 按照缓冲区的大小，循环读取
                while ((len = is.read(buffer)) != -1) {
                    // 根据读取的长度写入到os对象中
                    baos.write(buffer, 0, len);
                }
                // 释放资源
                is.close();
                baos.close();
                // 返回字符串
                DataInfo = new String(baos.toByteArray());
            } else {
                DataInfo = "链接失败";
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return DataInfo;
    }

    public static String GetDataByGet(String getUrl) {
        String DataInfo = "";
        try {
            // 根据地址创建URL对象
            URL testUrl = new URL(getUrl);
            //忽略证书验证
            // 根据URL对象打开链接
            HttpURLConnection urlConnection = null;

            // Create a trust manager that does not validate certificate chains 创建一个trust manager
            TrustManager[] trustAllCerts = new TrustManager[]{new X509TrustManager() {
                public X509Certificate[] getAcceptedIssuers() {
                    return null;
                }

                public void checkClientTrusted(X509Certificate[] certs, String authType) {
                }

                public void checkServerTrusted(X509Certificate[] certs, String authType) {
                }
            }};
            // Install the all-trusting trust manager 信任所有证书
            try {
                // 注意这部分一定要
                HttpsURLConnection.setDefaultHostnameVerifier(new NullHostNameVerifier());
                SSLContext sc = SSLContext.getInstance("TLS");
                sc.init(null, trustAllCerts, new SecureRandom());
                HttpsURLConnection.setDefaultSSLSocketFactory(sc.getSocketFactory());
                urlConnection = (HttpURLConnection) testUrl.openConnection();
                // 设置请求的方式
                urlConnection.setRequestMethod("GET");
                // 设置请求的超时时间
                urlConnection.setReadTimeout(4000);
                urlConnection.setConnectTimeout(4000);
                // 设置请求的头
                urlConnection.setRequestProperty("Connection", "keep-alive");
                // 设置请求的头
                urlConnection.setRequestProperty("Content-Type",
                        "application/x-www-form-urlencoded");
                // 设置请求的头
                urlConnection
                        .setRequestProperty("User-Agent",
                                "Mozilla/5.0 (Windows NT 6.3; WOW64; rv:27.0)" +
                                        " Gecko/20100101 Firefox/27.0");
                urlConnection.setDoOutput(true); // 发送设置允许输出

            } catch (Exception e) {
                e.printStackTrace();
            }
            //获取输出流
            if (urlConnection.getResponseCode() == 200) {
                // 获取响应的输入流对象
                InputStream getIS = urlConnection.getInputStream();
                // 创建字节输出流对象
                ByteArrayOutputStream getBAOS = new ByteArrayOutputStream();
                // 定义读取的长度
                int len = 0;
                // 定义缓冲区
                byte buffer[] = new byte[1024];
                // 按照缓冲区的大小，循环读取
                while ((len = getIS.read(buffer)) != -1) {
                    // 根据读取的长度写入到os对象中
                    getBAOS.write(buffer, 0, len);
                }
                // 释放资源
                getIS.close();
                getBAOS.close();
                // 返回字符串
                DataInfo = new String(getBAOS.toByteArray());
            } else {
                DataInfo = "链接失败";
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return DataInfo;
    }
}
